pro GetArraySizeInfo,singlename,datatype,sdsname,NumberofPixels,NumberofLines,TotalDayLines,TotalChannels

;get the most basic image info


;for IDL 5.3
;splitfilename=strsplit(singlename,'/',/extract)

splitfilename=str_sep(singlename,'/')
tempsize=size(splitfilename)
productname=strmid(splitfilename[tempsize[1]-1],0,8)

fileId = HDF_SD_START(singlename,/READ)
case 1 of
   datatype eq 'MODIS': begin
     scanid=HDF_SD_ATTRFIND(fileid,'Number of Scans')
     if scanid ne -1 then HDF_SD_ATTRINFO,fileid,scanid,DATA=NumberofScans

     scandayid=HDF_SD_ATTRFIND(fileid,'Number of Day mode scans')
     if scandayid ne -1 then HDF_SD_ATTRINFO,fileid,scandayid,DATA=TotalDayScans

     scannightid=HDF_SD_ATTRFIND(fileid,'Number of Night mode scans')
     if scannightid ne -1 then HDF_SD_ATTRINFO,fileid,scannightid,DATA=TotalNightScans

     viewframesid=HDF_SD_ATTRFIND(fileid,'Max Earth View Frames')
     if viewframesid ne -1 then HDF_SD_ATTRINFO,fileid,viewframesid,DATA=EarthViewFrames

     case 1 of
         productname eq 'MOD021KM' : begin
           TotalChannels=36
           NumberofPixels=EarthViewFrames[0]
           NumberofLines=NumberofScans[0]*10
           TotalDayLines=TotalDayScans[0]*10
           TotalNightLines=TotalNightScans[0]*10
         end
         productname eq 'MOD02HKM' : begin
           TotalChannels=7
           NumberofPixels=EarthViewFrames*2
           NumberofLines=NumberofScans[0]*20
           TotalDayLines=TotalDayScans[0]*20
           TotalNightLines=TotalNightScans[0]*20
         end
         productname eq 'MOD02QKM' : begin
           TotalChannels=2
           NumberofPixels=EarthViewFrames*4
           NumberofLines=NumberofScans[0]*40
           TotalDayLines=TotalDayScans[0]*40
           TotalNightLines=TotalNightScans[0]*40
         end
     endcase
   end
   datatype eq 'MAS': begin
     dimensionid=hdf_sd_select(fileid,hdf_sd_nametoindex(fileid,'CalibratedData'))
     hdf_sd_getinfo,dimensionid,dims=dimensions

     NumberofLines=dimensions[2]
     TotalChannels=dimensions[1]
     NumberofPixels=dimensions[0]
     TotalDayLines=NumberofLines
   end
   datatype eq 'LEVEL2': begin
     dimensionid=hdf_sd_select(fileid,hdf_sd_nametoindex(fileid,sdsname))
     hdf_sd_getinfo,dimensionid,dims=dimensions

     if dimensions[0] eq 2 then begin
       NumberofLines=dimensions[2]
       TotalChannels=1
       NumberofPixels=dimensions[1]
     endif else begin
       NumberofLines=dimensions[1]
       TotalChannels=1
       NumberofPixels=dimensions[0]
     endelse

     TotalDayLines=NumberofLines
   end
endcase

HDF_SD_END, fileId

end

