pro GetLatLongArrays,datatype,InputXsize,InputYsize,l1bname,latitude,longitude,fileloop

case 1 of
   datatype eq 'MODIS' or datatype eq 'LEVEL2': begin
     LatitudeSDS='Latitude'
     LongitudeSDS='Longitude'
   end
   datatype eq 'MAS': begin
     LatitudeSDS='PixelLatitude'
     LongitudeSDS='PixelLongitude'
   end
endcase

fileId = HDF_SD_START(l1bname, /READ)

case 1 of
  datatype eq 'MODIS' or datatype eq 'LEVEL2' : begin
    read_scaled_sds,latitude,range,fileid,LatitudeSDS,/scaleNo,/offsetNo
    read_scaled_sds,longitude,range,fileid,LongitudeSDS,/scaleNo,/offsetNo
  end
  datatype eq 'MAS': begin
   read_scaled_sds,latitude,range,fileid,LatitudeSDS,/scaleNo,/offsetNo,/fillNo,/validrangeNo
   read_scaled_sds,longitude,range,fileid,LongitudeSDS,/scaleNo,/offsetNo,/fillNo,/validrangeNo
  end
endcase

HDF_SD_END, fileId

if InputXsize gt 200 and InputYsize gt 200 then begin
  latitude=congrid(latitude,InputXsize,InputYsize,/interp)
  longitude=smart_interp(longitude,InputXsize,InputYsize)
endif
;if InputXsize gt 0 and InputXsize lt 250  and InputYsize gt 0 and InputYsize lt 250 then begin
;  latitude=congrid(latitude,InputXsize*10,InputYsize*10,/interp)
;  longitude=smart_interp(longitude,InputXsize*10,InputYsize*10)
;  InputXsize=InputXsize*10
;  InputYsize=InputYsize*10
;endif
end
