pro GetMASdata,channel,file,SDSXSize,SDSYSIZE,tile,tilesize,temp,scaleNo=scaleNo, offsetNo=offsetNo, fillNo=fillNo


varname='CalibratedData'

;tileLineIndex is the line number in the file at the beginning of the tile
tileLineIndex=(tile)*tilesize

if tileLineIndex+tilesize+1 gt SDSYSize then  begin
  tilesize=SDSYSize-tileLineIndex-1
endif


tilevector=[716,1,tilesize+1]
startvector=[0,channel-1,tileLineIndex]

fileId = HDF_SD_START(file, /READ)

index = HDF_SD_NAMETOINDEX(fileId, varname)
sdsid = HDF_SD_SELECT(fileId, index)
HDF_SD_GETDATA, sdsid, imagedata,count=tilevector,start=startvector

scale_sds_name='scale_factor'
IF NOT Keyword_Set(scaleNo) THEN BEGIN
   scaleId = HDF_SD_ATTRFIND(sdsid,scale_sds_name)
   IF scaleId NE -1 THEN BEGIN
      HDF_SD_ATTRINFO, sdsid, scaleId, DATA=scale_factor
   ENDIF
ENDIF

imagedata=fix(imagedata)*scale_factor[channel-1]

HDF_SD_ENDACCESS, sdsid
HDF_SD_END, fileId

;the calling routine expects the image array to be of the form
;[pixels,lines,channels].  Of course (!) the MAS and MODIS data
;arrays are ordered completely differently. Bah, humbug.
temp=fltarr(716,tilesize+1)

temp[0:715,0:tilesize]=imagedata[0:715,0,0:tilesize]  

end
